/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2008, 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <boost/variant/get.hpp>

#include "libtkdb/exception.h"
#include "editor/location.h"

using namespace Tk::Editor;

Location:: Location(Tk::Db::Database *database, const Tk::Db::Id &id)
  : Item(database, id)
{
}

void
Location:: set_property(const Tk::String &name, Tk::Db::Data::Value &value)
{
  _database->set_property("location", _id, name, value);
}

Tk::String
Location:: get_store_cell_text()
{
  try {
    Tk::Db::Data::Value name(_database->get_property("location", _id, "name"));
    return name.get_datum_value<Tk::String>();
  }
  catch (Tk::Db::PropertyNotSet &pns)
    {
      return Tk::String("Location #") + Tk::String(_id);
    }
  
}
