/*
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_PSEUDO_RANDOM_H__
#define __TK_PSEUDO_RANDOM_H__

#include <string>
#include <vector>

#include "randomness.h"
#include "retriever_registry.h"

namespace Tk {

  namespace Random {

    class PseudoRandom : public Retriever
    {
    private:
      static char   _state[256];
      //static char * _old_state;
      static bool   _state_initialised;

      static void initialise_state();
    protected:
      virtual Buffer * retrieve();
    public:
      PseudoRandom(unsigned chars);
      ~PseudoRandom();
    };

    class PseudoRandomType : public RetrieverType
    {
    public:
      virtual bool is_true_randomness();
      virtual unsigned get_preferred_block_size();
      virtual Retriever * new_retriever(unsigned count);
    };

  };

};


#endif /* __TK_PSEUDO_RANDOM_H__ */
